<template>
  <div>
    <el-container>
      <el-aside width="320px">
        <div class="JKWTree-tree">
          <h3>工序损耗管理</h3>
          <!-- <el-tree :data="treeData" :props="defaultProps" @node-click="handleNodeClick"></el-tree> -->
		  <el-tree :data="treeData" @node-click="handleNodeClick"></el-tree>
        </div>
      </el-aside>
      <el-container>
        <el-main>
          <div class="gva-search-box">
            <!-- <el-form ref="elSearchFormRef" :inline="true" :model="searchInfo" class="demo-form-inline" :rules="searchRule" @keyup.enter="onSubmit">
              <el-form-item label="创建日期" prop="createdAt">
                <template #label>
        <span>
          创建日期
          <el-tooltip content="搜索范围是开始日期（包含）至结束日期（不包含）">
            <el-icon><QuestionFilled /></el-icon>
          </el-tooltip>
        </span>
                </template>
                <el-date-picker v-model="searchInfo.startCreatedAt" type="datetime" placeholder="开始日期" :disabled-date="time=> searchInfo.endCreatedAt ? time.getTime() > searchInfo.endCreatedAt.getTime() : false"></el-date-picker>
                —
                <el-date-picker v-model="searchInfo.endCreatedAt" type="datetime" placeholder="结束日期" :disabled-date="time=> searchInfo.startCreatedAt ? time.getTime() < searchInfo.startCreatedAt.getTime() : false"></el-date-picker>
              </el-form-item>
              <el-form-item>
                <el-button type="primary" icon="search" @click="onSubmit">查询</el-button>
                <el-button icon="refresh" @click="onReset">重置</el-button>
              </el-form-item>
            </el-form> -->
			<div class="gva-btn-list">
				<el-button type="primary" icon="upload" @click="addNextClick">增加同级科目</el-button>
				<el-button type="primary" icon="plus" @click="editClick">修改</el-button>
				<el-button type="primary" icon="upload" @click="delClick">删除</el-button>
				<el-button type="primary" icon="plus" @click="addChildClick">增加子科目</el-button>
			    <!-- <el-button type="primary" icon="upload" @click="importClick">导出到excel</el-button> -->
			</div>
          </div>
          <!-- <div class="gva-table-box">
            <div class="gva-btn-list">
			  <el-button type="primary" icon="upload" @click="">导出到excel</el-button>
			  <el-button type="primary" icon="plus" @click="getDetails(2)">详情</el-button>
            </div>
            <el-table
                ref="multipleTable"
                style="width: 100%"
                tooltip-effect="dark"
                :data="tableData"
                row-key="ID"
                @selection-change="handleSelectionChange"
            >
              <el-table-column align="left" label="设备编号" prop="address" width="120" />
              <el-table-column align="left" label="设备名称" prop="image" width="120" />
              <el-table-column align="left" label="生产工序" prop="name" width="120" />
			  <el-table-column align="left" label="日定额" prop="address" width="120" />
			  <el-table-column align="left" label="千件工价" prop="image" width="120" />
			  <el-table-column align="left" label="机长" prop="name" width="120" />
			  <el-table-column align="left" label="副机" prop="address" width="120" />
			  <el-table-column align="left" label="调墨" prop="image" width="120" />
			  <el-table-column align="left" label="二手" prop="name" width="120" />
			  <el-table-column align="left" label="飞达" prop="address" width="120" />
			  <el-table-column align="left" label="辅助" prop="image" width="120" />
			  <el-table-column align="left" label="放卷" prop="name" width="120" />
			  <el-table-column align="left" label="分切1" prop="address" width="120" />
			  <el-table-column align="left" label="分切2" prop="image" width="120" />
			  <el-table-column align="left" label="检验" prop="name" width="120" />
			  <el-table-column align="left" label="使用部门" prop="address" width="120" />
			  <el-table-column align="left" label="设备编组" prop="image" width="120" />
			  <el-table-column align="left" label="创建用户" prop="name" width="120" />
			  <el-table-column align="left" label="创建时间" prop="address" width="120" />
			  <el-table-column align="left" label="修改时间" prop="image" width="120" />
			  <el-table-column align="left" label="UNIQID" prop="name" width="120" >
              </el-table-column>
            </el-table>
            <div class="gva-pagination">
              <el-pagination
                  layout="total, sizes, prev, pager, next, jumper"
                  :current-page="page"
                  :page-size="pageSize"
                  :page-sizes="[10, 30, 50, 100]"
                  :total="total"
                  @current-change="handleCurrentChange"
                  @size-change="handleSizeChange"
              />
            </div>
          </div> -->
          <el-dialog v-model="dialogFormVisible" style="width: 600px;" :before-close="closeDialog" :title="`当前编码:${code}`" destroy-on-close>
            <el-scrollbar height="200px">
              <el-form :model="formData" :inline="true" label-position="right" ref="elFormRef" :rules="rule" label-width="80px">
                <el-form-item label="编号:"  prop="code" >
                  <el-input v-model="formData.code" style="width: 400px;" :clearable="true"/>
                </el-form-item>
                <el-form-item label="名称:"  prop="name" >
                  <el-input v-model="formData.name" style="width: 400px;" :clearable="true"/>
                </el-form-item>
                <el-form-item label="基本损耗:"  prop="sys_rate0" >
                  <el-input v-model="formData.sys_rate0" style="width: 145px;" :clearable="true"/>
                </el-form-item>
				<el-form-item label="损耗率:"  prop="sys_rate1" >
				  <el-input v-model="formData.sys_rate1" style="width: 145px;" :clearable="true"/>
				</el-form-item>
				<el-form-item label="备注机型:"  prop="remark" >
				  <el-input v-model="formData.remark" style="width: 400px;" :clearable="true"/>
				</el-form-item>
              </el-form>
            </el-scrollbar>
            <template #footer>
              <div class="dialog-footer">
                <el-button @click="closeDialog">取 消</el-button>
                <el-button type="primary" @click="enterDialog">确 定</el-button>
              </div>
            </template>
          </el-dialog>

          <el-dialog v-model="detailShow" style="width: 600px" lock-scroll :before-close="closeDetailShow" :title="`当前编码:${processData.sys_bh}`" destroy-on-close>
            <el-scrollbar height="200px">
              <el-descriptions column="1" border>
                <el-descriptions-item label="编号">
                  {{ processData.sys_bh }}
                </el-descriptions-item>
                <el-descriptions-item label="名称">
                  {{ processData.sys_mc }}
                </el-descriptions-item>
              </el-descriptions>
			  <el-descriptions column="2" border>
			    <el-descriptions-item label="基本损耗">
			      {{ processData.sys_rate0 }}
			    </el-descriptions-item>
			    <el-descriptions-item label="损耗率">
			      {{ processData.sys_rate1 }}
			    </el-descriptions-item>
			  </el-descriptions>
			  <el-descriptions column="1" border>
			  <el-descriptions-item label="备注(机型)">
			    {{ processData.remark }}
			  </el-descriptions-item>
			  </el-descriptions>
			  
			  <!-- <el-form :model="processData" label-position="right" ref="elFormRef" :rules="rule" label-width="80px">
			    <el-form-item label="编号:"  prop="sys_bh" >
			      <el-input v-model="processData.sys_bh" :clearable="true" />
			    </el-form-item>
			    <el-form-item label="名称:"  prop="sys_mc" >
			      <el-input v-model="processData.sys_mc" :clearable="true" />
			    </el-form-item>
			    <el-form-item label="基本损耗:"  prop="sys_rate0" >
			      <el-input v-model="processData.sys_rate0" :clearable="true"  />
			    </el-form-item>
				<el-form-item label="损耗率:"  prop="sys_rate1" >
				  <el-input v-model="processData.sys_rate1" :clearable="true" />
				</el-form-item>
				<el-form-item label="备注(机型):"  prop="备注（机型）" >
				  <el-input v-model="item" :clearable="true"  />
				</el-form-item>
			  </el-form> -->
            </el-scrollbar>
          </el-dialog>
        </el-main>
      </el-container>
    </el-container>
  </div>
</template>

<script setup>
import {
  getProcessLoss,
  getProcess,
  getProcessCode,
  getProcessAdd,
  getProcessEdit,
  getProcessDel
} from '@/api/mes/job'
import {
  createCompany,
  deleteCompany,
  deleteCompanyByIds,
  updateCompany,
  findCompany,
  getCompanyList
} from '@/api/company'

// 全量引入格式化工具 请按需保留
import { getDictFunc, formatDate, formatBoolean, filterDict, ReturnArrImg, onDownloadFile } from '@/utils/format'
import { ElMessage, ElMessageBox } from 'element-plus'
import { ref, reactive } from 'vue'

defineOptions({
    name: 'Company'
})

const treeData=ref([])
const Process = async() => {
  const getProcesss = await getProcess()
  // console.log(getProcesss.data)
  if (getProcesss.code === 0) {
	  
	  const transformedData = getProcesss.data.map(item => ({
	          label: item.sys_mc,
			  params: {
			    code: item.sys_bh,
			  },
	          children: item.child.map(sysItem => ({
	            label: sysItem.sys_mc,
	            params: {
	              code: sysItem.sys_bh,
	            },
	  				children: sysItem.children.map(syssItem => ({
	  				  label: syssItem.sys_mc,
	  				  params: {
	  				    code: syssItem.sys_bh,
	  				  },
					  children: syssItem.childrens.map(syssItems => ({
					    label: syssItems.sys_mc,
					    params: {
					      code: syssItems.sys_bh,
					    },
					    
					  }))
					  
	  				}))
	          })),
	        }));
	  // console.log(transformedData)
    treeData.value = transformedData
  }
}
Process()
const handleNodeClick = async(node,check) => {
	if(node.children==null){
		sys_bh.value = node.params.code;
		getDetails();
	}else{
		if(node.children.length==0){
			sys_bh.value = node.params.code;
			getDetails();
		}
	}
  //存放当前节点的nodeId
 //  if (node.children) {
	// 	sys_bh.value = node.params.code;
	// 	getDetails();
	// }
	// if (node.paramsss) {
	// 		sys_bh.value = node.paramsss.code;
	// 		getDetails();
	// 		// return false;
	// 	}
	// if (node.paramss) {
	// 		sys_bh.value = node.paramss.code;
	// 		getDetails();
	// 		return false;
	// 	}
	// if (node.params) {
	// 		sys_bh.value = node.params.code;
	// 		getDetails();
	// 	}
	code.value=node.params.code
	// console.log(code.value);
     // console.log(node,check);
}
// 自动化生成的字典（可能为空）以及字段
const formData = ref({
        code: '',
        name: '',
        sys_rate0: 0.000,
		sys_rate1: 0.0000,
		remark: '',
        })

const processData = ref({})
// 验证规则
const rule = reactive({
})

const searchRule = reactive({
  createdAt: [
    { validator: (rule, value, callback) => {
      if (searchInfo.value.startCreatedAt && !searchInfo.value.endCreatedAt) {
        callback(new Error('请填写结束日期'))
      } else if (!searchInfo.value.startCreatedAt && searchInfo.value.endCreatedAt) {
        callback(new Error('请填写开始日期'))
      } else if (searchInfo.value.startCreatedAt && searchInfo.value.endCreatedAt && (searchInfo.value.startCreatedAt.getTime() === searchInfo.value.endCreatedAt.getTime() || searchInfo.value.startCreatedAt.getTime() > searchInfo.value.endCreatedAt.getTime())) {
        callback(new Error('开始日期应当早于结束日期'))
      } else {
        callback()
      }
    }, trigger: 'change' }
  ],
})

const elFormRef = ref()
const elSearchFormRef = ref()

// =========== 表格控制部分 ===========
const page = ref(1)
const total = ref(0)
const pageSize = ref(10)
const tableData = ref([])
const searchInfo = ref({})
// const defaultProps = {
//   children: 'child',
//   label: 'sys_mc'
// };
const sys_bh = ref()
const code = ref()
const newcode = ref()
const addNextClick = async() => {
	if(code.value==undefined){
		return false;
	}
  const getProcessCodes = await getProcessCode({code:code.value,same_item:1,child_item:0})
  if (getProcessCodes.code === 0) {
	  if(getProcessCodes.data.length<=3){
		  switch(getProcessCodes.data.length){
			  case 1:newcode.value=`00${getProcessCodes.data}`
			  break;
			  case 2:newcode.value=`0${getProcessCodes.data}`
			  break
		  }
	  }else{
		  newcode.value=getProcessCodes.data
	  }
	  formData.value.code=newcode.value
	  openDialog()
	  // console.log(newcode.value)
  }
}

const addChildClick = async() => {
	if(code.value==undefined){
		return false;
	}
  const getProcessCodes = await getProcessCode({code:code.value,same_item:0,child_item:1})
  if (getProcessCodes.code === 0) {
	  formData.value.code=getProcessCodes.data
	  openDialog()
	  // console.log(newcode.value)
  }
}
const editClick = async() => {
	const ProcessDetail = await getProcessLoss({code:code.value})
	// console.log(ProcessDetail)
	if (ProcessDetail.code === 0) {
	    formData.value.code=ProcessDetail.data[0].sys_bh
	    formData.value.name=ProcessDetail.data[0].sys_mc
	    formData.value.sys_rate0=ProcessDetail.data[0].sys_rate0
	    formData.value.sys_rate1=ProcessDetail.data[0].sys_rate1
	    formData.value.remark=ProcessDetail.data[0].remark
	}
	type.value = 'update'
	dialogFormVisible.value = true
	
	  // console.log(newcode.value)
}
const delClick = async() => {
	ElMessageBox.confirm('确定要删除吗?', '提示', {
	    confirmButtonText: '确定',
	    cancelButtonText: '取消',
	    type: 'warning'
	}).then(() => {
		ProcessDel()
	    })
}
const ProcessDel = async() => {
  const getProcessDels = await getProcessDel({ code: code.value })
  if (getProcessDels.code === 0) {
	  ElMessage({
	          type: 'success',
	          message: '删除成功'
	      })
	  Process()
	  // delRes.value=1
	  // console.log(delRes.value)
  }
}
// 重置
const onReset = () => {
  searchInfo.value = {}
  getTableData()
}

// 搜索
const onSubmit = () => {
  elSearchFormRef.value?.validate(async(valid) => {
    if (!valid) return
    page.value = 1
    pageSize.value = 10
    getTableData()
  })
}

// 分页
const handleSizeChange = (val) => {
  pageSize.value = val
  getTableData()
}

// 修改页面容量
const handleCurrentChange = (val) => {
  page.value = val
  getTableData()
}

// 查询
const getTableData = async() => {
  const table = await getCompanyList({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
  if (table.code === 0) {
    tableData.value = table.data.list
    total.value = table.data.total
    page.value = table.data.page
    pageSize.value = table.data.pageSize
  }
}

getTableData()

// ============== 表格控制部分结束 ===============

// 获取需要的字典 可能为空 按需保留
const setOptions = async () =>{
}

// 获取需要的字典 可能为空 按需保留
setOptions()


// 多选数据
const multipleSelection = ref([])
// 多选
const handleSelectionChange = (val) => {
    multipleSelection.value = val
}

// 删除行
const deleteRow = (row) => {
    ElMessageBox.confirm('确定要删除吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
    }).then(() => {
            deleteCompanyFunc(row)
        })
    }


// 批量删除控制标记
const deleteVisible = ref(false)

// 多选删除
const onDelete = async() => {
      const ids = []
      if (multipleSelection.value.length === 0) {
        ElMessage({
          type: 'warning',
          message: '请选择要删除的数据'
        })
        return
      }
      multipleSelection.value &&
        multipleSelection.value.map(item => {
          ids.push(item.ID)
        })
      const res = await deleteCompanyByIds({ ids })
      if (res.code === 0) {
        ElMessage({
          type: 'success',
          message: '删除成功'
        })
        if (tableData.value.length === ids.length && page.value > 1) {
          page.value--
        }
        deleteVisible.value = false
        getTableData()
      }
    }

// 行为控制标记（弹窗内部需要增还是改）
const type = ref('')

// 更新行
const updateCompanyFunc = async(row) => {
    const res = await findCompany({ ID: row.ID })
    type.value = 'update'
    if (res.code === 0) {
        formData.value = res.data.recompany
        dialogFormVisible.value = true
    }
}


// 删除行
const deleteCompanyFunc = async (row) => {
    const res = await deleteCompany({ ID: row.ID })
    if (res.code === 0) {
        ElMessage({
                type: 'success',
                message: '删除成功'
            })
            if (tableData.value.length === 1 && page.value > 1) {
            page.value--
        }
        getTableData()
    }
}

// 弹窗控制标记
const dialogFormVisible = ref(false)


// 查看详情控制标记
const detailShow = ref(false)


// 打开详情弹窗
const openDetailShow = () => {
  detailShow.value = true
}


// // 打开详情
// const getDetails = async (row) => {
//   // 打开弹窗
//   // const res = await findCompany({ ID: row })
//   // if (res.code === 0) {
//   //   formData.value = res.data.recompany
//   //   openDetailShow()
//   // }
//   openDetailShow()
// }

const getDetails = async () => {
	const getProcessLosss = await getProcessLoss({code:sys_bh.value})
	if (getProcessLosss.code === 0) {
	  // getProcessLosss.data[0].forEach(function(i,index){
	  // 	console.log(i)
	  // })
	  processData.value=getProcessLosss.data[0];
	  // formData.value.code=getProcessLosss.data[0].sys_bh
	  // formData.value.name=getProcessLosss.data[0].sys_mc
	  // formData.value.sys_rate0=getProcessLosss.data[0].sys_rate0
	  // formData.value.sys_rate1=getProcessLosss.data[0].sys_rate1
	  // formData.value.remark=getProcessLosss.data[0].remark
	  openDetailShow()
	}
}

// 关闭详情弹窗
const closeDetailShow = () => {
  detailShow.value = false
  formData.value = {
        code: '',
        name: '',
        sys_rate0: 0.000,
		sys_rate1: 0.0000,
		remark: '',
        }
}


// 打开弹窗
const openDialog = () => {
    type.value = 'create'
    dialogFormVisible.value = true
}

// 关闭弹窗
const closeDialog = () => {
    dialogFormVisible.value = false
    formData.value = {
        code: '',
        name: '',
        sys_rate0: 0.000,
		sys_rate1: 0.0000,
		remark: '',
        }
}
// 弹窗确定
const enterDialog = async () => {
     elFormRef.value?.validate( async (valid) => {
             if (!valid) return
              let res
              switch (type.value) {
                case 'create':
                  res = await getProcessAdd(formData.value)
                  break
                case 'update':
                  res = await getProcessEdit(formData.value)
                  break
                default:
                  res = await getProcessAdd(formData.value)
                  break
              }
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '创建/更改成功'
                })
                closeDialog()
				Process()
                // getTableData()
              }
      })
}

</script>

<style>
.JKWTree-container {
  display: flex;
}

.JKWTree-tree {
  width: 300px;
  background-color: #fff;
  padding: 10px;
  margin-right: 20px;
}

.JKWTree-tree h3 {
  font-size: 15px;
  font-weight: 700;
  margin: 10px 0;
}

.JKWTree-content {
  flex: 1;
}
</style>
